//+------------------------------------------------------------------+
//|                                                  DkzNkzMaker.mq4 |
//|                                           Author: Sergey Pekshev |
//|       Contact Information: icq: 345-961-467, skype: alllance.com |
//+------------------------------------------------------------------+
#property strict
#property indicator_chart_window
struct   InfoStruct { string name; double percent; int NKZ; datetime bankTime; double bankPercent; };

//   -> OBJ_PERIOD_M1, OBJ_PERIOD_M5, OBJ_PERIOD_M5, OBJ_PERIOD_M30, OBJ_PERIOD_H1, OBJ_PERIOD_H4, OBJ_PERIOD_D1, OBJ_PERIOD_W1, OBJ_PERIOD_MN1, OBJ_ALL_PERIODS
// :
// double DKZ_timeframe = OBJ_ALL_PERIODS;                            //    
// double DKZ_timeframe = OBJ_PERIOD_M15;                             //    M15
// double DKZ_timeframe = OBJ_PERIOD_M1|OBJ_PERIOD_M5|OBJ_PERIOD_M15; //    M1  M5  M15

//////////////////////////////////////////////////////////////////////
                                         
InfoStruct Info[]      = {                  
// {  , % ,   ,  ., %   . }    =  /  ;
                                              // %  -> http://www.global-rates.com/interest-rates/central-banks/central-banks.aspx
   { "EURUSD", 0.30, 2480, "10:30", 0.30 },   // 3100 12.5 http://www.cmegroup.com/trading/fx/g10/euro-fx_performance_bonds.html
   { "GBPUSD", 0.75, 2800, "10:30", 0.63 },   // 1750 6.25 http://www.cmegroup.com/trading/fx/g10/british-pound_performance_bonds.html
   { "USDJPY", 0.35, 2400 },                  // 3000 12.5 http://www.cmegroup.com/trading/fx/g10/japanese-yen_performance_bonds.html#sortField=exchange&sortAsc=true&sector=FX&exchange=CME&clearingCode=J1
   { "USDCAD", 1.00, 1670 },                  // 1670 10   http://www.cmegroup.com/trading/fx/g10/canadian-dollar_performance_bonds.html#sortField=exchange&sortAsc=true&sector=FX&exchange=CME&clearingCode=C1
   { "AUDUSD", 2.75, 2200 },                  // 2200 10   http://www.cmegroup.com/trading/fx/g10/australian-dollar_performance_bonds.html
   { "NZDUSD", 3.75, 2100 },                  // 2100 10   http://www.cmegroup.com/trading/fx/g10/new-zealand-dollar_performance_bonds.html
   
   { "XAUUSD", 0,    4000 },                  // 4000 http://www.cmegroup.com/trading/fx/g10/euro-fx_performance_bonds.html#sortField=exchange&sortAsc=true&exchange=CMX&sector=METALS&clearingCode=GC
   { "#NQ100", 0,    1800 },                  // 18000 25 0.25 http://www.cmegroup.com/trading/equity-index/us-index/nasdaq-100_performance_bonds.html
   { "#SP500", 0,    920  },                  // 23000 25 0.1 http://www.cmegroup.com/trading/equity-index/us-index/sandp-500_contract_specifications.html
};

//  
int      HotKey1         = 49;                //  1      
int      HotKey2         = 50;                //  2      / 2
int      HotKey3         = 51;                //  3   
int      HotKey4         = 16;                //  Shift  ,       
int      HotKey5         = 82;                //  R       (      )
int      HotKey6         = 66;                //  B   
int      HotKey7         = 53;                //  5 /    ,  .    ATR   .    ATR.     
int      HotKey8         = 54;                //  6 /  Hi  Low .
int      HotKey9         = 17;                //  Ctrl      ,  , Esc -  
int      HotKey10        = 52;                //  4   ,       
int      HotKey11        = 55;                //  7  ,   
int      HotKey12        = 56;                //  8    
int      HotKey13        = 9;                 //  Tab        .    int ZonaLengthPlus
int      HotKey14        = 89;                //  Y  Ctrl-Y  ./.   
int      HotKey15        = 85;                //  U ./.  .      ,   30 ,    (  )

//--------------------------------------------------------------------

int      ZonaAlert       = 1;                 // 1 -     , 0 -   (             )
int      ZonaLengthPlus  = 20000;             //            HotKey13

//  
int      DKZ_color       = clrDarkOrange;     // 
int      DKZ_length      = 100000;            //  (    )
int      DKZ_angle       = 5000;              //    (    )
int      DKZ_timeframe   = OBJ_ALL_PERIODS;   //    , .  

//  
int      NKZ_color       = clrMediumSeaGreen; //  
int      NKZ_length      = 300000;            //  (    )
int      NKZ_angle       = 10000;             //    (    )
int      NKZ_timeframe   = OBJ_ALL_PERIODS;   //    , .  
int      NKZ_mode        = 0;                 // 0 -   5%    5%, 1 -   10% , 2 -   10%   
int      NKZd_color      = C'123,210,163';    //    
double   NKZd_list[]     = {0.25, 0.5};       //   


//  
int      B_auto          = 1;                 //   . 1 - , 0 -  (   )
int      B_manual        = 1;                 //    .,       ( . ) 1 - , 0 - ,     
int      B_days[]        = {3, 4, 5};         //      . (0-, 1, 2, 3, 4, 5, 6-) 
int      B_length        = 0;                 //  (    ),  0 -      
int      B_orderZ        = 4;                 //    . 
int      B_colorZ        = clrOrange;         //    .
int      B_color         = clrBlue;           //  
int      B_width         = 2;                 //  
int      B_style         = 0;                 //  
int      B_back          = 1;                 //      - 1,   - 0
int      B_timeframe     = OBJ_ALL_PERIODS;   //    , .  

// ATR 
int      ATR_hist        = 30;                //     ATR
int      ATR_W1          = 1;                 //    1 - , 0 - 
int      ATR_colorH      = clrRed;            //       
int      ATR_colorL      = clrGreen;          //       
int      ATR_width       = 1;                 //  
int      ATR_style       = 1;                 //  
int      ATR_back        = 1;                 //      - 1,   - 0
int      ATR_timeframe   = OBJ_ALL_PERIODS;   //    , .  

// Hi Low 
int      HiLow_count     = 100;               //    
int      HiLow_color     = clrSteelBlue;      // 
int      HiLow_colorF    = clrRed;            //  
int      HiLow_width     = 2;                 //  
int      HiLow_style     = 0;                 //  
int      HiLow_back      = 1;                 //      - 1,   - 0
int      HiLow_timeframe = OBJ_ALL_PERIODS;   //    , .  

//    
int      Zigzag_color    = clrSteelBlue;      // 
int      Zigzag_width    = 5;                 //  
int      Zigzag_style    = 0;                 //  
int      Zigzag_back     = 1;                 //      - 1,   - 0

//  
int      Gann_length     = 100000;            //      (   )
double   Gann_Scale[]    = {0.25, 0.50, 1};   //   (*10  )
int      Gann_change     = 1;                 //   - 1,    - 0
int      Gann_color      = clrBlue;           // 
int      Gann_width      = 2;                 //  
int      Gann_style      = 0;                 //  
int      Gann_back       = 0;                 //      - 1,   - 0
int      Gann_timeframe  = OBJ_ALL_PERIODS;   //    , .  

//  
int      Correct_length  = 7000;              //         ( )
int      Correct_time    = 60 * 5;            //        ,     50% 
int      Correct_color1  = clrBlue;           //   
int      Correct_width1  = 1;                 //  
int      Correct_style1  = 2;                 //  
int      Correct_back1   = 0;                 //      - 1,   - 0
int      Correct_color2  = clrRed;            //  
int      Correct_width2  = 2;                 //  
int      Correct_style2  = 0;                 //  
int      Correct_back2   = 0;                 //      - 1,   - 0

//  
datetime A_time          = "23:00";           //       
int      A_count         = 100;               //  
int      A_length1       = 86400;             //    
int      A_color1        = clrRed;            //   ( )
int      A_width1        = 3;                 //  
int      A_style1        = 0;                 //  
int      A_back1         = 0;                 //      - 1,   - 0
int      A_color2        = clrOrangeRed;      //   (    )
int      A_width2        = 2;                 //  
int      A_style2        = 0;                 //  
int      A_back2         = 0;                 //      - 1,   - 0
int      A_timeframe     = OBJ_ALL_PERIODS;   //    , .  

//  
int      sound           = 1;                 //   1 - , 0 - 
string   sound_Error     = "expert.wav";      //   
string   sound_Zona      = "tick.wav";        //      
string   sound_Blevel    = "alert2.wav";      //     
string   sound_Correct   = "wait.wav ";       //      50%    

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

int      MouseX          = 0; 
int      MouseY          = 0;
int      InfoKey         = -1;   //       ( )
datetime BankTime        = NULL;
int      ModeDkzNkz      = 0;
int      ModeZigzag      = 0;

struct   ListRectStruct { string name; double price; datetime time;};
ListRectStruct ListRect[];

int      AtrFL           = 1;
int      HiLowFL         = 1;
int      CorrectFL       = 1;
int      RectFL          = 1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
{
   ///////////////////////////////////////////////////////////////////////////////////////////////
   if (AccountInfoInteger(ACCOUNT_LOGIN) == 278402 || AccountInfoInteger(ACCOUNT_LOGIN) == 78757)
   {
      for (int i = ArraySize(Info) - 1; i >= 0; i--) Info[i].name = Info[i].name + "_m";
      //NKZ_mode   = 0;              // 1 -   10% , 0 -   5%    5%
      DKZ_color  = C'255,198,128'; //  
      NKZ_color  = C'123,210,163'; //  
      NKZd_color = C'123,210,163'; //   
      B_colorZ   = C'128,191,255'; //    .
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////
   
   ChartSetInteger(0, CHART_EVENT_OBJECT_CREATE, 1);
   ChartSetInteger(0, CHART_EVENT_OBJECT_DELETE, 1);
   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   if (UninitializeReason() != REASON_CHARTCHANGE) //     
   {
      ChartSetInteger(0, CHART_SHOW_TRADE_LEVELS, true); 
      InitRect("ALL_OBJECTS_RECT_CORRECT");
   }

   //         bankTime
   for (int i = ArraySize(Info) - 1; i >= 0; i--)
   {
      if (Info[i].name == _Symbol) 
      {
         BankTime = Info[i].bankTime;
         InfoKey = i;
         break;
      }
   }
   if (ObjectGetString(0, "MouseInfo", OBJPROP_TEXT) == "DkzNkzMaker") ModeDkzNkz = 1;
   if (ObjectGetString(0, "MouseInfo", OBJPROP_TEXT) == "/\\/\\/\\")   ModeZigzag = 1;
   if (ObjectCreate(0, "MouseInfo", OBJ_LABEL, 0, 0, 0)) ObjectSetString(0, "MouseInfo", OBJPROP_TEXT, " ");
   ObjectSet("MouseInfo", OBJPROP_BACK, false);                    //    
   ObjectSet("MouseInfo", OBJPROP_SELECTED, false);                //    
   ObjectSet("MouseInfo", OBJPROP_SELECTABLE, false);              //   
   ObjectSet("MouseInfo", OBJPROP_FONT, "Arial");
   ObjectSet("MouseInfo", OBJPROP_FONTSIZE, 10);
   ObjectSet("MouseInfo", OBJPROP_COLOR, clrRed);
   ObjectSet("MouseInfo", OBJPROP_HIDDEN, true);                   //  (true)   (false)      
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   if (reason == REASON_REMOVE) //   
   {
      ChartSetInteger(0, CHART_SHOW_TRADE_LEVELS, true);
      GlobalVariableDel("DN_" + WindowHandle(_Symbol, 0));
      ObjectDelete("MouseInfo");
      DeleteByPrefix("LR_");
   }
}
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start()
{
   if (BankTime && B_auto && ArraySize(B_days))
   {
      BankTime = datetime(TimeHour(BankTime) + ":" + TimeMinute(BankTime));
      if (TimeCurrent() >= BankTime)
      {
         int dW = TimeDayOfWeek(BankTime);
         int ok = 0;
         for (int i = ArraySize(B_days) - 1; i >= 0; i--)
            if (dW == B_days[i]) { ok = 1; break; }
         if (ok)
         {
            ok = iBarShift(NULL, PERIOD_M1, BankTime, true);
            if (ok != -1) DrawBank(BankTime, iOpen(NULL, PERIOD_M1, ok), Info[InfoKey].bankPercent);
         }
      }
   }
   if (AtrFL)     DrawATR();
   if (HiLowFL)   DrawHiLow();
   if (CorrectFL) DrawCorrect();
   if (RectFL)    AlertRect();
}

void OnTimer()
{
   ChartSetInteger(0, CHART_SHOW_TRADE_LEVELS, true);
   EventKillTimer();
   ChartRedraw();
}

//+------------------------------------------------------------------+
//|   ChartEvent                                     |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         //    
                  const long& lparam,   //    long
                  const double& dparam, //  3  double
                  const string& sparam  //    string
                 )
{
   int sub_window;
   static datetime ZigzagTime  = 0;
   static double   ZigzagPrice = 0;
   static string   ZigzagName  = "";
   static int      ZigzagIndex = 0;

   
   if (id == CHARTEVENT_OBJECT_CREATE) InitRect(sparam);
   if (id == CHARTEVENT_OBJECT_DELETE) InitRect();
   if (id == CHARTEVENT_OBJECT_DRAG)   InitRect(sparam);
   if (id == CHARTEVENT_OBJECT_CHANGE)
   {
      InitRect(sparam);
      if (StringSubstr(sparam, 0, 5) == "Bank_")
      {
         DrawBank(datetime(StringSubstr(sparam, 5, 0)), 0, Info[InfoKey].bankPercent);
         return;
      }
   }
      
   if (id == CHARTEVENT_MOUSE_MOVE)
   {
      MouseY = dparam;
      MouseX = lparam;
      DrawMouseInfo();
      if (ModeZigzag && ZigzagPrice)
      {
         datetime time;
         double price;
         ChartXYToTimePrice(0, MouseX, MouseY + 1, sub_window, time, price);
         if (!sub_window && price)
         {
            ObjectSet(ZigzagName, OBJPROP_TIME2, time);
            ObjectSet(ZigzagName, OBJPROP_PRICE2, price);
         }
      }
      return;
   }
   if(id == CHARTEVENT_OBJECT_CLICK)
   {
      if (ModeZigzag)
      {
         static string name;
         ChartXYToTimePrice(0, MouseX, MouseY + 1, sub_window, ZigzagTime, ZigzagPrice);
         if (!ZigzagIndex) name = "Zigzag_" + GetTickCount() + "_";
         ZigzagName = name + ZigzagIndex++;
         ObjectCreate(ZigzagName, OBJ_TREND, 0, ZigzagTime, ZigzagPrice, ZigzagTime, ZigzagPrice);
         ObjectSet(ZigzagName, OBJPROP_COLOR, Zigzag_color);          // 
         ObjectSet(ZigzagName, OBJPROP_WIDTH, Zigzag_width);          // 
         ObjectSet(ZigzagName, OBJPROP_STYLE, Zigzag_style);          // 
         ObjectSet(ZigzagName, OBJPROP_BACK, Zigzag_back);            //    
         ObjectSet(ZigzagName, OBJPROP_RAY, false);                   //   
      }
      return;
   }
   
   if (id == CHARTEVENT_KEYDOWN)
   {
      //Comment(" : " + lparam); PlaySound("stops.wav"); return;
      datetime time1;                  //  
      double   price1;                 //  
      double   price2, price3, price4; //   
      int      HiLow;                  // 1 - Hi, -1 - Low

      Comment("");
      ChartXYToTimePrice(0, MouseX, MouseY + 1, sub_window, time1, price1);
      
      //  
      if (lparam == HotKey13)
      {
         string name;
         int total = ObjectsTotal();
         for (int i = 0; i < total; i++)
         {
            if (ObjectType(name = ObjectName(i)) == OBJ_RECTANGLE)
            {   
               if (price1 <= ObjectGet(name, OBJPROP_PRICE1) && price1 >= ObjectGet(name, OBJPROP_PRICE2) && time1 >= ObjectGet(name, OBJPROP_TIME1) && time1 <= ObjectGet(name, OBJPROP_TIME2))
               {
                  ObjectSet(name, OBJPROP_TIME2, correctWeekend(ObjectGet(name, OBJPROP_TIME2), ObjectGet(name, OBJPROP_TIME2) + ZonaLengthPlus));
                  return;
               }
            }
         }
      }
      
      ///      ////////////////////////////////////////////////////////////////////
      if (GlobalVariableCheck("RM_" + WindowHandle(_Symbol, 0)))
      {
         if (lparam == 9)
         {
            if (!ModeDkzNkz) ModeDkzNkz = 1; else ModeDkzNkz = 0;
            GlobalVariableSet("DN_" + WindowHandle(_Symbol, 0), ModeDkzNkz);
            ModeZigzag = 0;
         }
      }
      else
      {
         ModeDkzNkz = 1;  
      }
      ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
     
      //  
      if (lparam == HotKey9)
      {
         static int ttt;
         if (GetTickCount() - ttt < 400) 
         {
            ModeZigzag = 1;
            ModeDkzNkz = 0;
         }
         else
         {
            ttt = GetTickCount();
            ModeZigzag = ZigzagPrice = ZigzagIndex = 0;
            ObjectDelete(ZigzagName);
         }
      }
      DrawMouseInfo();
      
      //  ESC
      if (lparam == 27)
      {
         if (ModeZigzag)
         {
            int k;
            if ((k = StringFind(ZigzagName, "_", 7)) != -1) DeleteByPrefix(StringSubstr(ZigzagName, 0, k));
            ZigzagIndex = 0;
         }
      }

      //  ,  ,  
      if ((lparam == HotKey1 || lparam == HotKey2 || lparam == HotKey3 || lparam == HotKey10) && ModeDkzNkz || lparam == HotKey11)
      {
         if (InfoKey == -1 && lparam != HotKey11)
         {
            Comment("      !");
            if (sound) PlaySound(sound_Error);
            return;
         }
         
         //         
         string name;
         int zonaUpdate = 0;
         double zonaUpdateInfo = 0;
         for (int i = ObjectsTotal() - 1; i >= 0; i--)
         {
            if (ObjectType(name = ObjectName(i)) == OBJ_RECTANGLE)
            {   
               if (ObjectGet(name, OBJPROP_SELECTED) && price1 <= ObjectGet(name, OBJPROP_PRICE1) && price1 >= ObjectGet(name, OBJPROP_PRICE2) && time1 >= ObjectGet(name, OBJPROP_TIME1) && time1 <= ObjectGet(name, OBJPROP_TIME2))
               {
                  if (StringSubstr(name, 0, 4) == "DKZ_") zonaUpdate = 1;
                  if (StringSubstr(name, 0, 3) == "NKZ")  zonaUpdate = 2;
                  if (StringSubstr(name, 0, 4) == "NKZ_") zonaUpdate = 3;
                  if (zonaUpdate)
                  {
                     price1 = ObjectGet(StringSubstr(name, 0, 24), OBJPROP_PRICE1);
                     time1 = datetime(StringSubstr(name, 5, 19));
                     zonaUpdateInfo = StringSubstr(name, 27, 0);
                     if (StringSubstr(name, 25, 1) == "H") HiLow = 1;
                     if (StringSubstr(name, 25, 1) == "L") HiLow = -1;
                     break;
                  }
               }
            }
         }
         
         if (zonaUpdate)
         {
            if (!HiLow || !price1 || !zonaUpdateInfo)
            {
               Comment(" !      ");
               if (sound) PlaySound(sound_Error);
               return;
            }
         }

         //         
         if (!zonaUpdate)
         {
            double price_H, price_L;
            int shift_H, shift_L, shift;
            price_H = price_L = shift_H = shift_L = HiLow = NULL;
            shift = iBarShift(NULL, 0, time1, false);
            shift_L = iLowest(NULL, 0, MODE_LOW, 10 * 2, shift - 10);
            price_L = iLow(NULL, 0, shift_L);
            shift_H = iHighest(NULL, 0, MODE_HIGH, 10 * 2, shift - 10);
            price_H = iHigh(NULL, 0, shift_H);
            if (price1 > price_H) 
            {
               price1 = price_H;                // 
               time1 = iTime(NULL, 0, shift_H); // 
               HiLow = 1;                       // Hi
               
            }
            else if (price1 < price_L)
            {
               price1 = price_L;                // 
               time1 = iTime(NULL, 0, shift_L); // 
               HiLow = -1;                      // Low
            }
            else
            {
               Comment("  ,   ,   !");
               if (sound) PlaySound(sound_Error);
               return;
            }
   
            //      
            datetime time2 =  time1 + _Period * 60;
            if (time2 > TimeCurrent()) time2 = TimeCurrent();
            int tm[] = {1, 5, 15 , 30, 60, 240, 14400, 10080, 43200};
            for (int i = 0; i < ArraySize(tm); i++)
            {
               shift_L = iBarShift(NULL, tm[i], time1, true);
               shift_H = iBarShift(NULL, tm[i], time2, true);
               if (shift_L != -1 && shift_H != -1)
               {
                  if (HiLow == -1)
                     time1 = iTime(NULL, tm[i], iLowest(NULL, tm[i], MODE_LOW, shift_L - shift_H, shift_H + 1)); // 
                  else
                     time1 = iTime(NULL, tm[i], iHighest(NULL, tm[i], MODE_HIGH, shift_L - shift_H, shift_H + 1)); // 
                  break;
               }
            }
            
            //        ,       
            string prefix;
            if (lparam == HotKey1) prefix = "DKZ__";
            if (lparam == HotKey3) prefix = "NKZ__";
            prefix += time1;
            for (int i = ObjectsTotal() - 1; i >= 0; i--)
            {
               if (ObjectType(name = ObjectName(i)) == OBJ_RECTANGLE)
               {
                  if (lparam == HotKey2)
                  {
                     if (StringSubstr(name, 5, 19) == time1 && StringSubstr(name, 0, 3) == "NKZ")
                     {
                        zonaUpdateInfo = StringSubstr(name, 27, 0);
                        break;
                     }                  
                  }
                  else if (StringFind(name, prefix, 0) == 0)
                  {
                     zonaUpdateInfo = StringSubstr(name, 27, 0);
                     break;
                  }
               }
            }
         }
         
         //    
         if (lparam == HotKey1 && !zonaUpdate || zonaUpdate == 1)
         {
            if (!zonaUpdateInfo) zonaUpdateInfo = Info[InfoKey].percent;
            double DKZ = price1 * zonaUpdateInfo / 100;
            if (DKZ == 0)
            {
               Comment("   !");
               if (sound) PlaySound(sound_Error);
               return;
            }
            price2 = price1 - DKZ * HiLow;
            price4 = price2 + DKZ / 10 * HiLow;
            DrawZone("DKZ__", " - " + MathFloor(DKZ * MathPow(10, _Digits)) + ". (" + DoubleToString(zonaUpdateInfo, 2) + "%)", time1, price1, time1 + DKZ_angle, price2, price2, price4, DKZ_length, DKZ_color, DKZ_timeframe, zonaUpdateInfo);
            return;
         }

         //  
         if (lparam == HotKey2 && !zonaUpdate || zonaUpdate == 2)
         {
            if (!zonaUpdateInfo) zonaUpdateInfo = Info[InfoKey].NKZ;
            double NKZ = zonaUpdateInfo;
            if (NKZ == 0)
            {
               Comment("   !");
               if (sound) PlaySound(sound_Error);
               return;
            }
            for (int i = ArraySize(NKZd_list) - 1; i >=0; i--)
            {
               if (!NKZd_list[i]) continue;
               NKZ = zonaUpdateInfo * NKZd_list[i];
               price2 = price1 - NKZ * _Point * HiLow;
               if (NKZ_mode == 1)
               {
                  price3 = price2 - NKZ * _Point * 0.1 * HiLow;  //   , 10% 
                  price4 = price2;                               //   , 10% 
               }
               else if (NKZ_mode == 2)
               {
                  price3 = price2 + NKZ * _Point * 0.1 * HiLow;  //   , 10%  
                  price4 = price2;                               //   , 10%  
               }
               else
               {
                  price3 = price2 + NKZ * _Point * 0.05 * HiLow; //   ,  5%   
                  price4 = price2 - NKZ * _Point * 0.05 * HiLow; //   ,  5%   
               }
               DrawZone("NKZ" + i + "_", " " + NKZd_list[i] + " - " + NKZ + ".", time1, price1, time1 + NKZ_angle, price2, price3, price4, NKZ_length / 2, NKZd_color, NKZ_timeframe, zonaUpdateInfo);
            }
            return;
         }
      
         // 
         if (lparam == HotKey3 && !zonaUpdate || zonaUpdate == 3)
         {
            if (!zonaUpdateInfo) zonaUpdateInfo = Info[InfoKey].NKZ;
            double NKZ = zonaUpdateInfo;
            if (NKZ == 0)
            {
               Comment("   !");
               if (sound) PlaySound(sound_Error);
               return;
            }
            price2 = price1 - NKZ * _Point * HiLow;
            if (NKZ_mode == 1)
            {
               price3 = price2 - NKZ * _Point * 0.1 * HiLow;  //   , 10% 
               price4 = price2;                               //   , 10% 
            }
            else if (NKZ_mode == 2)
            {
               price3 = price2 + NKZ * _Point * 0.1 * HiLow;  //   , 10%  
               price4 = price2;                               //   , 10%  
            }
            else
            {
               price3 = price2 + NKZ * _Point * 0.05 * HiLow; //   ,  5%   
               price4 = price2 - NKZ * _Point * 0.05 * HiLow; //   ,  5%   
            }
            DrawZone("NKZ__", " - " + NKZ + ".", time1, price1, time1 + NKZ_angle, price2, price3, price4, NKZ_length, NKZ_color, NKZ_timeframe, zonaUpdateInfo);
            return;
         }

         //  
         if (lparam == HotKey10)
         {
            datetime time2 = correctWeekend(time1, time1 + Gann_length);
            static datetime timegann;
            static int i = 0;
            name = "Gann_" + time1;
            if (timegann != time1) i = 0;
            timegann = time1;
            if (i == ArraySize(Gann_Scale))
            {
               i = 0;
               ObjectDelete(name);
            }
            else
            {
               HiLow *= -1;
               if (!Gann_change) name += Gann_Scale[i] * HiLow;
               ObjectDelete(name);
               ObjectCreate(0, name, OBJ_GANNLINE, 0, time1, price1, time2, 0);
               ObjectSetDouble(0, name, OBJPROP_SCALE, Gann_Scale[i] * HiLow);
               ObjectSetText(name, "   " + Gann_Scale[i] * HiLow);
               ObjectSet(name, OBJPROP_TIMEFRAMES, Gann_timeframe); //   
               ObjectSet(name, OBJPROP_WIDTH, Gann_width);          // 
               ObjectSet(name, OBJPROP_STYLE, Gann_style);          // 
               ObjectSet(name, OBJPROP_COLOR, Gann_color);          // 
               i++;
            }
            if (sound) PlaySound(sound_Zona);
            return;
         }
         //  
         if (lparam == HotKey11) DrawCorrect(time1, price1, HiLow);
      }

      //   
      if (lparam == HotKey6 && ModeDkzNkz)
      {
         if (BankTime)
         {
            MqlDateTime date;
            TimeToStruct(time1, date);
            datetime BankTimeManual = datetime(date.year + "." + date.mon + "." + date.day + " " + TimeHour(BankTime) + ":" + TimeMinute(BankTime));
            if (B_manual)
            {
               int dW = TimeDayOfWeek(BankTimeManual);
               int ok = 0;
               for (int i = ArraySize(B_days) - 1; i >= 0; i--)
                  if (dW == B_days[i]) { ok = 1; break; }
               if (!ok)
               {
                  Comment("         !   B_manual = 0;");
                  if (sound) PlaySound(sound_Error);
                  return;
               }
            }
            if (TimeCurrent() >= BankTimeManual)
            {
               int shift, tm[] = {1, 5, 15 , 30, 0};
               for (int i = 0; i < ArraySize(tm); i++)
               {
                  shift = iBarShift(NULL, tm[i], BankTimeManual, true);
                  if (shift != -1)
                  {
                     DrawBank(BankTimeManual, iOpen(NULL, tm[i], shift), Info[InfoKey].bankPercent);
                     if (sound) PlaySound(sound_Blevel);
                     break;
                  }
               }
            }
            else
            {
               Comment("     !");
               if (sound) PlaySound(sound_Error);
            }
         }
         return;
      }
      
      //   (    ,      )
      if (lparam == HotKey4)
      {
         string name;
         int total = ObjectsTotal();
         
         //    /Atr /HiLow 
         for (int i = 0; i < total; i++)
         {
            if (
                  ObjectType(name = ObjectName(i)) == OBJ_TREND 
                  && 
                  (
                     StringSubstr(name, 0, 5) == "Bank_"
                     || StringSubstr(name, 0, 4) == "ATR_"
                     || StringSubstr(name, 0, 6) == "HiLow_"
                     || StringSubstr(name, 0, 7) == "Zigzag_"
                     || StringSubstr(name, 0, 7) == "Correct"
                  )
               )
            {
               int x, x1, x2, x3, y, y1, y2, y3;
               ChartTimePriceToXY(0, 0, ObjectGet(name, OBJPROP_TIME1), ObjectGet(name, OBJPROP_PRICE1), x1, y1);
               ChartTimePriceToXY(0, 0, ObjectGet(name, OBJPROP_TIME2), ObjectGet(name, OBJPROP_PRICE2), x2, y2);
               ChartTimePriceToXY(0, 0, time1, price1, x3, y3);
               if (x1 > x2) { x = x1; x1 = x2; x2 = x; }
               if (y1 > y2) { y = y1; y1 = y2; y2 = y; }
               int p = 8;
               if (x3 >= x1 - p && x3 <= x2 + p && y3 >= y1 - p && y3 <= y2 + p)
               {
                  ChartTimePriceToXY(0, 0, ObjectGet(name, OBJPROP_TIME1), ObjectGet(name, OBJPROP_PRICE1), x1, y1);
                  ChartTimePriceToXY(0, 0, ObjectGet(name, OBJPROP_TIME2), ObjectGet(name, OBJPROP_PRICE2), x2, y2);
                  double d = 2 * MathAbs(x2*(y1-y3)+x1*(y3-y2)+x3*(y2-y1))/2 / MathSqrt(MathPow(x2 - x1, 2) + MathPow(y2 - y1, 2));    
                  if (d <= p)
                  {
                     ObjectDelete(name);
                     if (StringSubstr(name, 0, 7) == "Correct")
                     {
                        ObjectDelete("Correct1");
                        ObjectDelete("Correct2");
                        
                     }
                     if (StringSubstr(name, 0, 7) == "Zigzag_")
                     {
                        int k;
                        if ((k = StringFind(name, "_", 7)) != -1) DeleteByPrefix(StringSubstr(name, 0, k));
                     }
                     if (StringSubstr(name, 0, 5) == "Bank_") DeleteByPrefix("BankZ_" + StringSubstr(name, 5, 24));
                     if (sound) PlaySound(sound_Zona);
                     return;
                  }
               }
            }
         }

         //   ,        
         for (int i = 0; i < total; i++)
         {
            if (ObjectType(name = ObjectName(i)) == OBJ_RECTANGLE)
            {   
               if (price1 <= ObjectGet(name, OBJPROP_PRICE1) && price1 >= ObjectGet(name, OBJPROP_PRICE2) && time1 >= ObjectGet(name, OBJPROP_TIME1) && time1 <= ObjectGet(name, OBJPROP_TIME2))
               {
                  //    
                  if (StringSubstr(name, 0, 6) == "BankZ_")
                  {
                     DeleteByPrefix(StringSubstr(name, 0, 24));
                     if (sound) PlaySound(sound_Zona);
                     return;
                  }
                  //   
                  ObjectDelete(name);                      // .  
                  ObjectDelete(StringSubstr(name, 0, 24)); // .    
                  if (sound) PlaySound(sound_Zona);
                  return;
               }
            }
         }
         Comment("    !");
         if (sound) PlaySound(sound_Error);
         return;
       }

      //   
      if (lparam == HotKey5)
      {
         string name;
         for (int i = ObjectsTotal() - 1; i >= 0; i--)
         {
            name = ObjectName(i);
            if (ObjectGetInteger(0, name, OBJPROP_SELECTED))
            {
               if (ObjectType(name) == OBJ_TREND)
               { 
                  if (ObjectGet(name, OBJPROP_PRICE1) == ObjectGet(name, OBJPROP_PRICE2)) 
                     ObjectSetInteger(0, name, OBJPROP_SELECTED, 0);
                  else
                     ObjectSet(name, OBJPROP_PRICE2, ObjectGet(name, OBJPROP_PRICE1));
               }
               if (ObjectType(name) == OBJ_RECTANGLE)
               { 
                     ObjectSetInteger(0, name, OBJPROP_SELECTED, 0);
               }
            }
         }
      }      
      
      // ATR 
      if (lparam == HotKey7) DrawATR(time1);

      // HiLow 
      if (lparam == HotKey8) DrawHiLow(1);

      //   
      if (lparam == HotKey12) DrawAlevel();
      
      if (lparam == HotKey14) ChartSetInteger(0, CHART_SHOW_PERIOD_SEP, bool(ChartGetInteger(0, CHART_SHOW_PERIOD_SEP) - 1));
      if (lparam == HotKey15) 
      {
         ChartSetInteger(0, CHART_SHOW_TRADE_LEVELS, bool(ChartGetInteger(0, CHART_SHOW_TRADE_LEVELS) - 1));
         EventSetTimer(30);
      }
   }
}

//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
datetime correctWeekend(datetime time1, datetime time2)
{
   datetime time = time1;
   int d3 = TimeDayOfYear(time2);
   for (int i = TimeDayOfYear(time1); i <= d3; i++)
   {
      if (TimeDayOfWeek(time) == 6 || TimeDayOfWeek(time) == 0) time2 += 86400 * 2; //    ,       
      if (TimeDayOfWeek(time) == 6)
      {
         i++;
         time += 86400;
      }
      time += 86400;
   }
   return time2;
}

//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void DrawMouseInfo()
{
   if(MouseY) ObjectSet("MouseInfo", OBJPROP_YDISTANCE, MouseY);
   if(MouseX) ObjectSet("MouseInfo", OBJPROP_XDISTANCE, MouseX + 13);
   if (ModeDkzNkz == 1 && GlobalVariableCheck("RM_" + WindowHandle(_Symbol, 0)))
      ObjectSetString(0, "MouseInfo", OBJPROP_TEXT, "DkzNkzMaker");
   else if (ModeZigzag == 1) 
      ObjectSetString(0, "MouseInfo", OBJPROP_TEXT, "/\\/\\/\\");
   else
      ObjectSetString(0, "MouseInfo", OBJPROP_TEXT, " ");
}

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
int DeleteByPrefix(string o_prefix)
{
   string name;
   int result = 0;
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      name = ObjectName(i);
      if (StringFind(name, o_prefix, 0) == 0) 
      {
         ObjectDelete(name);   
         result = 1;
      }
   }
   return result;
}

//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void DrawZone(string name, string descr, datetime time1, double price1, datetime time2, double price2, double price3, double price4, int length, int clr, int timeframe, double info)
{
   //  
   name += time1;
   ObjectCreate(name, OBJ_TREND, 0, 0, 0, 0, 0);
   ObjectSet(name, OBJPROP_TIME1, time1);
   ObjectSet(name, OBJPROP_PRICE1, price1);
   if (!ObjectGet(name, OBJPROP_TIME2))                  //  time2    ,  , ..    (   )
      ObjectSet(name, OBJPROP_TIME2, time2);
   else   
      time2 = ObjectGet(name, OBJPROP_TIME2);            //  time2     (   ) 
   ObjectSet(name, OBJPROP_PRICE2, price2);
   ObjectSet(name, OBJPROP_COLOR, clr);                  // 
   ObjectSet(name, OBJPROP_TIMEFRAMES, timeframe);       //   
   ObjectSet(name, OBJPROP_BACK, true);                  //    
   ObjectSet(name, OBJPROP_SELECTED, false);             //    
   ObjectSet(name, OBJPROP_RAY, false);                  //   
   ObjectSet(name, OBJPROP_STYLE, 0);                    // 
   ObjectSet(name, OBJPROP_WIDTH, 1);                    // 
   
   //  
   if (price1 > price2) name += "_H"; else name += "_L";
   name += "_" + info;
   if (price3 < price4) { price1 = price3; price3 = price4; price4 = price1; }
   ObjectCreate(name, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
   ObjectSet(name, OBJPROP_TIME1, time2);
   ObjectSet(name, OBJPROP_PRICE1, price3);
   if (!ObjectGet(name, OBJPROP_TIME2)) 
      ObjectSet(name, OBJPROP_TIME2, correctWeekend(time2, time2 + length)); //  time2    ,  , ..    (    )
   ObjectSet(name, OBJPROP_PRICE2, price4);
   ObjectSetText(name, descr);                           // 
   ObjectSet(name, OBJPROP_COLOR, clr);                  // 
   ObjectSet(name, OBJPROP_TIMEFRAMES, timeframe);       //   
   ObjectSet(name, OBJPROP_SELECTED, false);             //    
   ObjectSet(name, OBJPROP_BACK, true);                  //    

   string prefix = StringSubstr(name, 1, 3);
   if (sound && (prefix == "KZ_" || prefix == "KZ1")) PlaySound(sound_Zona);
   InitRect();
}

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void DrawBank(datetime time1, double price1, double percent)
{
   //  
   int newBank = 0;
   string descr = "", name = "Bank_" + time1;          //  Bank_  ,    
   datetime time2 = time1 +  B_length;
   if (!B_length)
   {
      MqlDateTime date;
      TimeToStruct(time1, date);
      time2 = datetime(date.year + "." + date.mon + "." + date.day + " 23:59");
   }
   time2 = correctWeekend(time1, time2);
   if (ObjectFind(name) == -1) 
   {
      if (sound) PlaySound(sound_Blevel);
      newBank = 1;
   }
   else
   {
      string pr = ObjectDescription(name);
      StringReplace(pr, descr, "");
      StringReplace(pr, ", ", ".");
      percent = double(pr);
   }
   ObjectCreate(name, OBJ_TREND, 0, 0, 0, 0, 0);
   ObjectSet(name, OBJPROP_TIME1, time1);
   if (!price1) price1 = ObjectGet(name, OBJPROP_PRICE1); //  price1  ,      ..    
   ObjectSet(name, OBJPROP_PRICE1, price1);
   if (!ObjectGet(name, OBJPROP_TIME2))                   //  time2    ,  , ..   
      ObjectSet(name, OBJPROP_TIME2, time2);
   else   
      time2 = ObjectGet(name, OBJPROP_TIME2);             //  time2    . (  )
   ObjectSet(name, OBJPROP_PRICE2, price1);
   ObjectSetText(name, descr + " " + percent + "%");    //          
   ObjectSet(name, OBJPROP_TIMEFRAMES, B_timeframe);      //   
   ObjectSet(name, OBJPROP_COLOR, B_color);               // 
   ObjectSet(name, OBJPROP_WIDTH, B_width);               // 
   ObjectSet(name, OBJPROP_STYLE, B_style);               //    
   ObjectSet(name, OBJPROP_BACK, B_back);                 //    
   //ObjectSet(name, OBJPROP_SELECTED, false);            //    
   ObjectSet(name, OBJPROP_RAY, false);                   //   


   //  
   double priceZ1, priceZ2, indentZ, heightZ;
   int k;
   heightZ = price1 * percent / 100 / 10;
   for(int i = 1; i <= B_orderZ * 2; i++)
   {
      k = i;
      name = "BankZ_" + time1 + " " + i;
      if (i > B_orderZ) k = -(i - B_orderZ);
      priceZ1 = price1 + price1 * percent * k / 100;
      priceZ2 = priceZ1 - heightZ * k / MathAbs(k);
      if (priceZ1 < priceZ2) { double price = priceZ1; priceZ1 = priceZ2; priceZ2 = price; }
      descr = DoubleToString((percent * k), 2) + "%";
      if (newBank) ObjectCreate(name, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
      ObjectSet(name, OBJPROP_TIME1, time1);
      ObjectSet(name, OBJPROP_PRICE1, priceZ1);
      ObjectSet(name, OBJPROP_TIME2, time2);
      ObjectSet(name, OBJPROP_PRICE2, priceZ2);
      ObjectSetText(name, descr);                         // 
      ObjectSet(name, OBJPROP_COLOR, B_colorZ);           // 
      ObjectSet(name, OBJPROP_TIMEFRAMES, B_timeframe);   //   
      ObjectSet(name, OBJPROP_SELECTED, false);           //    
      ObjectSet(name, OBJPROP_BACK, true);                //    
   }
   InitRect();
 }
 
//+------------------------------------------------------------------+
//|  ATR                                            |
//+------------------------------------------------------------------+
void DrawATR(datetime time1 = 0)
{
   static int ATR = 0, day = 0, summ = 0;
   int update = 0;

   //  ATR
   if (day != TimeDay(TimeCurrent()) || !ATR) //      
   {
      int finish;
      day = TimeDay(TimeCurrent());
      if (ATR_W1) finish = iBarShift(NULL, PERIOD_D1, iTime(NULL, PERIOD_W1, 0), false) + 1;
      else finish = 1;
      for (int i = ATR_hist - 1 + finish; i >= finish; i--)
         summ += (iHigh(NULL, PERIOD_D1, i) - iLow(NULL, PERIOD_D1, i)) / _Point;
      ATR = summ / ATR_hist;
   }
   if (!time1)
   {
      time1 = TimeCurrent();
      update = 1;
   }
   if (!update && sound) PlaySound(sound_Zona);
   MqlDateTime date;
   TimeToStruct(time1, date);
   time1 = datetime(date.year + "." + date.mon + "." + date.day + " 00:00");
   TimeToStruct(time1 + 86400, date);
   datetime time2 = datetime(date.year + "." + date.mon + "." + date.day + " 00:00");
   
   int shift = iBarShift(NULL, PERIOD_D1, time1, false);
   double price1 = iLow(NULL, PERIOD_D1, shift) + ATR * _Point;
   double price2 = iHigh(NULL, PERIOD_D1, shift) - ATR * _Point;
   
   //  
   string descr;
   int clr;
   for (int i = 1; i <= 2; i++)
   {
      descr = "ATR  Low " + ATR + ".";
      clr = ATR_colorL;
      if (i == 2)
      {
         price1 = price2;
         descr = "ATR  Hi " + ATR + ".";
         clr = ATR_colorH;
      }
      string name = "ATR_" + time1 + " " + i;                  //  ATR_  ,    
      
      if (!update && ObjectFind(name) != -1)
      { 
         ObjectDelete("ATR_" + time1 + " 1");
         ObjectDelete("ATR_" + time1 + " 2");
         return;
      }
      if (!update) ObjectCreate(name, OBJ_TREND, 0, 0, 0, 0, 0);
      ObjectSet(name, OBJPROP_TIME1, time1);
      ObjectSet(name, OBJPROP_PRICE1, price1);
      ObjectSet(name, OBJPROP_TIME2, time2);
      ObjectSet(name, OBJPROP_PRICE2, price1);
      ObjectSetText(name, descr);                              //          
      ObjectSet(name, OBJPROP_TIMEFRAMES, ATR_timeframe);      //   
      ObjectSet(name, OBJPROP_WIDTH, ATR_width);               // 
      ObjectSet(name, OBJPROP_STYLE, ATR_style);               // 
      ObjectSet(name, OBJPROP_COLOR, clr);                     // 
      ObjectSet(name, OBJPROP_BACK, ATR_back);                 //    
      ObjectSet(name, OBJPROP_SELECTED, false);                //    
      ObjectSet(name, OBJPROP_SELECTABLE, false);              //   
      ObjectSet(name, OBJPROP_RAY, false);                     //   
   }
   TimeToStruct(TimeCurrent(), date);
   time1 = datetime(date.year + "." + date.mon + "." + date.day + " 00:00");
   if (ObjectFind("ATR_" + time1 + " 1") != -1 || ObjectFind("ATR_" + time1 + " 2") != -1) AtrFL = 1; else AtrFL = 0;
}

//+------------------------------------------------------------------+
//|  Hi Low                                         |
//+------------------------------------------------------------------+
void DrawHiLow(datetime time1 = 0)
{
   int update = 0;
   if (!time1) update = 1;
   
   if (!update)
   {
      if (sound) PlaySound(sound_Zona);
      if (DeleteByPrefix("HiLow_"))  //      
      {
         HiLowFL = 0;
         return; 
      }
   }
   static datetime timeOld;
   time1 = TimeCurrent();
   datetime time2 = time1 + 86400;
   MqlDateTime date;
   TimeToStruct(time1, date);
   time1 = datetime(date.year + "." + date.mon + "." + date.day + " 00:00");
   TimeToStruct(time2, date);
   time2 = datetime(date.year + "." + date.mon + "." + date.day + " 00:00");
   timeOld = time1 ;
   double price1, price2;
   int shift, clr;
   for (int j = 0; j < HiLow_count; j++)
   {
      shift = iBarShift(NULL, PERIOD_D1, time1, true);
      if (shift != -1)
      {
         price1 = iLow(NULL, PERIOD_D1, shift);
         price2 = iHigh(NULL, PERIOD_D1, shift);
         clr = HiLow_color;
         if (TimeDayOfWeek(time1) == 5) clr = HiLow_colorF;
         //  
         for (int i = 1; i <= 2; i++)
         {
            if (i == 2) price1 = price2;
            string name = "HiLow_" + time1 + " " + i;             //  HiLow_  ,          
            if (!update) ObjectCreate(name, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(name, OBJPROP_TIME1, time1);
            ObjectSet(name, OBJPROP_PRICE1, price1);
            ObjectSet(name, OBJPROP_TIME2, time2);
            ObjectSet(name, OBJPROP_PRICE2, price1);
            ObjectSet(name, OBJPROP_TIMEFRAMES, HiLow_timeframe); //   
            ObjectSet(name, OBJPROP_WIDTH, HiLow_width);          // 
            ObjectSet(name, OBJPROP_STYLE, HiLow_style);          // 
            ObjectSet(name, OBJPROP_COLOR, clr);                  // 
            ObjectSet(name, OBJPROP_BACK, HiLow_back);            //    
            ObjectSet(name, OBJPROP_SELECTED, false);             //    
            //ObjectSet(name, OBJPROP_SELECTABLE, false);         //   
            ObjectSet(name, OBJPROP_RAY, false);                  //   
         }
      }
      if (update) break;
      time2 = time1;
      time1 -= 86400;
   }
   TimeToStruct(TimeCurrent(), date);
   time1 = datetime(date.year + "." + date.mon + "." + date.day + " 00:00");
   if (ObjectFind("HiLow_" + time1 + " 1") != -1 || ObjectFind("HiLow_" + time1 + " 2") != -1) HiLowFL = 1; else HiLowFL  = 0;
}

//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
void DrawCorrect(datetime time1 = 0, double price1 = 0, int HiLow = 0)
{  
   static int CorrectAlert, CorrectAlertTime;
   double price2, price3;
   datetime time2;
   string name = "Correct1";
   string name1 = "Correct2";
   int update = 0;

   if (!time1)
   {
      update = 1;
      time1 = ObjectGet(name, OBJPROP_TIME1);
      price1 = ObjectGet(name, OBJPROP_PRICE1);
      if  (price1 > ObjectGet(name, OBJPROP_PRICE2)) HiLow = 1; else HiLow = -1;
      if (!price1)
      {
         CorrectFL = 0; //    ,          
         return;
      } 
   }
   if (update || time1 != ObjectGet(name, OBJPROP_TIME1)) 
   {
      int shift = iBarShift(NULL, 0, time1, false);
      if (HiLow  == 1)
      {
         int shift = iLowest(NULL, 0, MODE_LOW, shift, 0);
         price2 = iLow(NULL, 0, shift);
         time2 = iTime(NULL, 0, shift);
         price3 = price1 - (price1 - price2) / 2;
      }
      else
      {
         shift = iHighest(NULL, 0, MODE_HIGH, shift, 0);
         price2 = iHigh(NULL, 0, shift);
         time2 = iTime(NULL, 0, shift);
         price3 = price1 + (price2 - price1) / 2;
      }
      price3 = price3;

      if (update)
         price1 = ObjectGet(name, OBJPROP_PRICE1);
      else
         CorrectAlert = CorrectAlertTime = 0; //   ,  
      ObjectCreate(name, OBJ_TREND, 0, 0, 0, 0, 0);
      ObjectSet(name, OBJPROP_TIME1, time1);
      ObjectSet(name, OBJPROP_PRICE1, price1);
      ObjectSet(name, OBJPROP_TIME2, time2);
      ObjectSet(name, OBJPROP_PRICE2, price2);
      ObjectSet(name, OBJPROP_RAY, false);                  //   
      ObjectSet(name, OBJPROP_COLOR, Correct_color1);       // 
      ObjectSet(name, OBJPROP_STYLE, Correct_style1);       // 
      ObjectSet(name, OBJPROP_WIDTH, Correct_width1);       // 
      ObjectSet(name, OBJPROP_BACK, Correct_back1);         //    
      
      ObjectCreate(name1, OBJ_TREND, 0, 0, 0, 0, 0);
      ObjectSet(name1, OBJPROP_TIME1, time1);
      ObjectSet(name1, OBJPROP_PRICE1, price3);
      ObjectSet(name1, OBJPROP_TIME2, correctWeekend(TimeCurrent(), TimeCurrent() + Correct_length)); //  time2    ,  , ..    (    )
      ObjectSet(name1, OBJPROP_PRICE2, price3);
      ObjectSetText(name1, "50%");                           // 
      ObjectSet(name1, OBJPROP_RAY, false);                  //   
      ObjectSet(name1, OBJPROP_COLOR, Correct_color2);       // 
      ObjectSet(name1, OBJPROP_STYLE, Correct_style2);       // 
      ObjectSet(name1, OBJPROP_WIDTH, Correct_width2);       // 
      ObjectSet(name1, OBJPROP_BACK, Correct_back2);         //    
      CorrectFL = 1;
   }
   else
   {
      ObjectDelete(name);
      ObjectDelete(name1);
      CorrectFL = 0;
   }
   if (CorrectFL && (HiLow == 1 && Bid >= price3) || (HiLow == -1 && Bid <= price3))
   {
      if (!CorrectAlert && TimeCurrent() - CorrectAlertTime >= Correct_time)
      {
         Alert("50%>>>  " + _Symbol);
         CorrectAlert = 1;
         CorrectAlertTime = TimeCurrent();
         PlaySound(sound_Correct);
         return;
      }
   }
   else
      CorrectAlert = 0;
   if (!update && sound) PlaySound(sound_Zona);
}

//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void DrawAlevel()
{
   if (sound) PlaySound(sound_Zona);
   int fl = 0;
   if (DeleteByPrefix("Alevel1_"))
   {
      fl = 1;
      if (DeleteByPrefix("Alevel2_")) return;
   }
   datetime time1 = TimeCurrent(), time2, time3;
   MqlDateTime date;
   TimeToStruct(time1, date);
   time1 = datetime(date.year + "." + date.mon + "." + date.day + " "+ A_time);
   time2 = time1 + A_length1;
   double price1, price3;
   string name;
   int shift;
   for (int j = 0; j < A_count; j++)
   {
      shift = iBarShift(NULL, 0, time1, true);
      if (shift != -1)
      {
         price1 = iClose(NULL, 0, shift);
         //     
         int shift, tm[] = {1, 5, 15 , 30, 60, 240, 14400, 10080, 43200};
         for (int i = 0; i < ArraySize(tm); i++)
         {
            shift = iBarShift(NULL, tm[i], time1, true);
            if (shift != -1)
            {
               price1 = iClose(NULL, tm[i], shift);
               break;
            }
         }
         if (price1)
         {
            name = "Alevel1_" + time1;
            time2 = correctWeekend(time1, time2);
            ObjectCreate(name, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(name, OBJPROP_TIME1, time1);
            ObjectSet(name, OBJPROP_PRICE1, price1);
            ObjectSet(name, OBJPROP_TIME2, time2);
            ObjectSet(name, OBJPROP_PRICE2, price1);
            ObjectSet(name, OBJPROP_TIMEFRAMES, A_timeframe); //   
            ObjectSet(name, OBJPROP_WIDTH, A_width1);         // 
            ObjectSet(name, OBJPROP_STYLE, A_style1);         // 
            ObjectSet(name, OBJPROP_COLOR, A_color1);         // 
            ObjectSet(name, OBJPROP_BACK, true);              //    
            ObjectSet(name, OBJPROP_SELECTED, false);         //    
            //ObjectSet(name, OBJPROP_SELECTABLE, false);     //   
            ObjectSet(name, OBJPROP_RAY, false);              //   
            if (time3 && fl)
            {
               name = "Alevel2_" + time1;
               ObjectCreate(name, OBJ_TREND, 0, 0, 0, 0, 0);
               ObjectSet(name, OBJPROP_TIME1, time1);
               ObjectSet(name, OBJPROP_PRICE1, price1);
               ObjectSet(name, OBJPROP_TIME2, time3);
               ObjectSet(name, OBJPROP_PRICE2, price3);
               ObjectSet(name, OBJPROP_TIMEFRAMES, A_timeframe); //   
               ObjectSet(name, OBJPROP_WIDTH, A_width2);         // 
               ObjectSet(name, OBJPROP_STYLE, A_style2);         // 
               ObjectSet(name, OBJPROP_COLOR, A_color2);         // 
               ObjectSet(name, OBJPROP_BACK, true);              //    
               ObjectSet(name, OBJPROP_SELECTED, false);         //    
               //ObjectSet(name, OBJPROP_SELECTABLE, false);     //   
               ObjectSet(name, OBJPROP_RAY, false);              //   
            }
            time3 = time1;
            price3 = price1;
         }
      }
      time2 = time1;
      time1 -= 86400;
   }
}

//+------------------------------------------------------------------+
//|                 |
//+------------------------------------------------------------------+
void CorrectRect(string name)
{
   datetime time;
   double price;
   if (ObjectGet(name, OBJPROP_TIME1) > ObjectGet(name, OBJPROP_TIME2))
   {
      time = ObjectGet(name, OBJPROP_TIME1);
      ObjectSet(name, OBJPROP_TIME1, ObjectGet(name, OBJPROP_TIME2));
      ObjectSet(name, OBJPROP_TIME2, time);
   }
   if (ObjectGet(name, OBJPROP_PRICE1) < ObjectGet(name, OBJPROP_PRICE2))
   {
      price = ObjectGet(name, OBJPROP_PRICE1);
      ObjectSet(name, OBJPROP_PRICE1, ObjectGet(name, OBJPROP_PRICE2));
      ObjectSet(name, OBJPROP_PRICE2, price);
   }
}

//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void InitRect(string nameP = "")
{
   RectFL = 0;
   if (!ZonaAlert) return;
   string name;

   if (nameP == "ALL_OBJECTS_RECT_CORRECT")
   {
      for (int i = ObjectsTotal() - 1; i >= 0; i--)
         if (ObjectType(name = ObjectName(i)) == OBJ_RECTANGLE) CorrectRect(name);
   }
   else if (nameP != "")
   {
      if (ObjectType(nameP) == OBJ_RECTANGLE) CorrectRect(nameP);
   }

   ArrayResize(ListRect, 0);
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      if (ObjectType(name = ObjectName(i)) == OBJ_RECTANGLE)
      {
         if (ObjectGet(name, OBJPROP_TIME1) <= TimeCurrent() && ObjectGet(name, OBJPROP_TIME2) >= TimeCurrent())
         {
            ArrayResize(ListRect, ArraySize(ListRect) + 1); 
            ListRect[ArraySize(ListRect) - 1].name = name;
            ListRect[ArraySize(ListRect) - 1].time = ObjectGet("LR_" + name, OBJPROP_TIME1);
            RectFL = 1;
         }
      }
   }
   //string t; for (int i = 0; i < ArraySize(ListRectName); i++) t += " " + ListRectName[i]; Alert(t);
}

//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void AlertRect()
{
   string name;
   string sss = "";
   double price_L, price_H, hight;
   int shift;
   for (int i = ArraySize(ListRect) - 1; i >= 0; i--)
   {
      name = ListRect[i].name;
/*
         if (ListRect[i].time)
         {
            int shift = iBarShift(NULL, 0, ListRect[i].time, false);
            if (shift)
            {
               price_L = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, shift, 0));
               price_H = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, shift, 0));
            }
            else
            {
               price_H = ObjectGet(name, OBJPROP_PRICE1);
               price_L = ObjectGet(name, OBJPROP_PRICE2);
            }
            
            hight = ObjectGet(name, OBJPROP_PRICE1) - ObjectGet(name, OBJPROP_PRICE2);
             
            /////////////////
            string k;
            if (price_H - ObjectGet(name, OBJPROP_PRICE1) >= hight || ObjectGet(name, OBJPROP_PRICE2) - price_L >= hight) 
            k = "";
            else
            k = "\r\n ||||||||||||||||||||||| ! |||||||||||||||||||||||";
            
            sss +=
            "\r\n-----------------------------------------------------------------------------------" +
            + k +
            "\r\n name: " + name +
            "\r\n time: " + ListRect[i].time +
            "\r\n shift: " + shift +
            "\r\n price_L: " + price_L +
            "\r\n price_H: " + price_H +
            "\r\n hight: " + DoubleToStr(hight * 100000, 0) +
            "\r\n hightH: " + DoubleToStr((price_H - ObjectGet(name, OBJPROP_PRICE1)) * 100000, 0) +
            "\r\n hightH: " + DoubleToStr((ObjectGet(name, OBJPROP_PRICE2) - price_L) * 100000, 0);
         }
         else
         {
            sss +=
            "\r\n-----------------------------------------------------------------------------------" +
            "\r\n name: " + name;
         }
*/        
      if (ObjectGet(name, OBJPROP_PRICE1) >= Bid && ObjectGet(name, OBJPROP_PRICE2) <= Bid)
      {
         if (ListRect[i].time)
         {
            int shift = iBarShift(NULL, 0, ListRect[i].time, false);
            if (shift)
            {
               price_L = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, shift, 0));
               price_H = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, shift, 0));
            }
            else
            continue;
            hight = ObjectGet(name, OBJPROP_PRICE1) - ObjectGet(name, OBJPROP_PRICE2);
         }
         if (!ListRect[i].time || price_H - ObjectGet(name, OBJPROP_PRICE1) >= hight || ObjectGet(name, OBJPROP_PRICE2) - price_L >= hight)
         {
            ListRect[i].time = TimeCurrent();
            
            string descr = ObjectDescription(name);
            if(descr == "") descr = name;
            Alert(" " + _Symbol + "    " + descr);
            PlaySound(sound_Correct);
            name = "LR_" + name;
            ObjectCreate(0, name, OBJ_LABEL, 0, 0, 0);
            ObjectSet(name, OBJPROP_TIME1, ListRect[i].time);
            ObjectSet(name, OBJPROP_TIMEFRAMES , EMPTY);            
            ObjectSet(name, OBJPROP_HIDDEN, true);
         }
      }
   }
   //Comment(sss);
}